SystemOrganization addCategory: #'GT-GlamourDebugger'!

GTDebugger subclass: #GTGlamourDebugger
	instanceVariableNames: 'rootBrowserContext'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-GlamourDebugger'!

!GTGlamourDebugger class methodsFor: 'accessing' stamp: 'AndreiChis 6/20/2013 12:28'!
defaultTitle
	^ 'Glamour Debugger'! !

!GTGlamourDebugger class methodsFor: 'testing' stamp: 'AndreiChis 6/27/2013 11:54'!
handlesContext: aContext

	^ (self locateBrowserContextFor: aContext) notNil ! !

!GTGlamourDebugger class methodsFor: 'accessing' stamp: 'AndreiChis 6/27/2013 11:54'!
locateBrowserContextFor: aContext

	^ self stackFilter locateBrowserContextFor: aContext! !

!GTGlamourDebugger class methodsFor: 'tools registry' stamp: 'AndreiChis 7/15/2013 16:39'!
registerToolsOn: registry

	"Add ourselves to registry. See [Smalltalk tools]" 
	registry registerDebugger: self withRank: 50.! !

!GTGlamourDebugger class methodsFor: 'accessing' stamp: 'AndreiChis 6/27/2013 11:52'!
stackFilter

	^ GTGlamourStackFilter ! !

!GTGlamourDebugger methodsFor: 'building' stamp: 'AndreiChis 6/20/2013 12:25'!
browserStructureFor: aGlmBrowser in: aComposite
	
	aComposite roassal 
		title: 'Browser structure';
		painting: [:view :b | 
			aGlmBrowser viewTreeOn: view ]! !

!GTGlamourDebugger methodsFor: 'building' stamp: 'AndreiChis 6/25/2013 19:03'!
browserTransmissionsIn: browser
	
	browser transmit
		from: #stack port: #context;
		to: #browser;
		andShow: [ :composite | self browserStructureFor: self rootBrowser in: composite ]! !

!GTGlamourDebugger methodsFor: 'building' stamp: 'AndreiChis 6/24/2013 20:53'!
debuggerStructureIn: browser

	browser
			row: [ :row | 
						row
							column: [ :c |
								c
									row: #stack;
									row: #code ];
							column: #browser ] span: 4;
			row: #inspector span: 3.! !

!GTGlamourDebugger methodsFor: 'building' stamp: 'AndreiChis 6/20/2013 12:25'!
debuggerTransmissionsIn: browser.
		
	super debuggerTransmissionsIn: browser.
	self browserTransmissionsIn: browser.! !

!GTGlamourDebugger methodsFor: 'building actions' stamp: 'AndreiChis 6/27/2013 12:17'!
debuggingActionsPragmas

	^ super debuggingActionsPragmas, { #glamourDebuggingAction }! !

!GTGlamourDebugger methodsFor: 'accessing' stamp: 'AndreiChis 6/25/2013 19:02'!
rootBrowser

	^ rootBrowserContext receiver! !

!GTGlamourDebugger methodsFor: 'accessing' stamp: 'AndreiChis 6/25/2013 19:07'!
rootBrowserContext

	^ rootBrowserContext! !

!GTGlamourDebugger methodsFor: 'scripting opening' stamp: 'AndreiChis 6/26/2013 15:51'!
startOn: aSession

	rootBrowserContext := self class locateBrowserContextFor: aSession context.
	super startOn: aSession! !

Object subclass: #GTGlamourStackFilter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-GlamourDebugger'!

!GTGlamourStackFilter class methodsFor: 'as yet unclassified' stamp: 'AndreiChis 6/28/2013 12:47'!
locateBrowserContextFor: aContext
	
	^ (aContext findContextSuchThat:  [ :ctx | 
		(ctx receiver class inheritsFrom: GLMPresentation)  and: [ ctx selector = #startOn: ] ]) ! !

!Object methodsFor: '*GT-GlamourDebugger' stamp: 'AndreiChis 6/19/2013 17:34'!
isGlamourBrowser

	^ false! !

DebugAction subclass: #GTGlamourStepToPresentationBuildAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-GlamourDebugger'!

!GTGlamourStepToPresentationBuildAction class methodsFor: 'as yet unclassified' stamp: 'AndreiChis 6/27/2013 12:23'!
gtActionType
	<gtContextGlamourDebuggingAction>! !

!GTGlamourStepToPresentationBuildAction methodsFor: 'testing' stamp: 'AndreiChis 6/27/2013 11:56'!
appliesToContext: aContext

	^ (GTGlamourStackFilter locateBrowserContextFor: aContext) notNil! !

!GTGlamourStepToPresentationBuildAction methodsFor: 'predicates' stamp: 'AndreiChis 7/12/2013 19:40'!
createPredicatForBlock: aBlock 

	^ StepContextPredicate new 
			baseContext: self debugger rootBrowserContext;
			predicate: aBlock! !

!GTGlamourStepToPresentationBuildAction methodsFor: 'actions' stamp: 'AndreiChis 6/29/2013 20:18'!
executeAction
	| presentationCreation presentationCode |
	presentationCreation := self presentationCreationPredicate.
	presentationCode := self presentationCodePredicate.

	self session stepUntil: presentationCreation.
	presentationCreation hasMatched ifTrue: [ 
		self session stepUntil: presentationCode ].
	presentationCode hasMatched ifTrue: [ 
		self session stepInto. ]
		
	! !

!GTGlamourStepToPresentationBuildAction methodsFor: 'initialize-release' stamp: 'AndreiChis 6/27/2013 11:49'!
initialize

	self label: 'Next presentation build'.
	self icon: GLMUIThemeExtraIcons glamorousPlay.! !

!GTGlamourStepToPresentationBuildAction methodsFor: 'predicates' stamp: 'AndreiChis 6/29/2013 20:27'!
presentationCodePredicate
	
	^ self createPredicatForBlock: [ :aContext |
			aContext selector = #glamourValueWithArgs: and: [ 
				aContext peekInstruction arguments size > 0 and: [ 
				 	#( #value #valueWithArguments:) includes: aContext peekInstruction argument ] ] ]
! !

!GTGlamourStepToPresentationBuildAction methodsFor: 'predicates' stamp: 'AndreiChis 6/29/2013 20:29'!
presentationCreationPredicate

	^ self createPredicatForBlock: [ :aContext |
			aContext methodClass = GLMPresentStrategy and: [ 
				aContext selector = #presentations and: [ 
					aContext isInitialnstruction ] ] ]

! !

!GLMBrowser methodsFor: '*GT-GlamourDebugger' stamp: 'AndreiChis 6/19/2013 17:34'!
isGlamourBrowser

	^ true! !
